/* pnx_attach.c */
extern void pnx_attach_boot();
extern void pnx_set_attachment(char *url, SV *ref);
extern void pnx_remove_attachment(char *url);
extern void pnx_set_default_attachment(SV *ref);
extern void pnx_remove_default_attachment();
extern HV *pnx_get_attachment_table();
extern int pnx_allow_attach(unsigned short *port, char **host, SV *func);
extern void pnx_disallow_attach(int port);
extern SV *pnx_attach(char *url);
/* pnx_call.c */
extern SV *pnx_rref_new(SV *obj, char *type);
extern SV *pnx_rrt_new(SV *obj);
extern SV *pnx_rrt_gp(SV *rrt);
extern char *pnx_rrt_type(SV *rrt);
extern SV *pnx_rrt_ref(SV *rrt);
extern void pnx_rrt_incr(SV *rrt, int count);
extern void pnx_rrt_decr(SV *rrt, int count);
extern void pnx_mb_pack_item(SV *bufref, SV **items, int n_items);
extern void pnx_mb_pack(SV *bufref, SV **items, int n_items);
extern void pnx_smb_unpack(SV *bufref, SV ***itemsp, int *n_items_ptr);
/* pnx_debug.c */
extern SV *db_newRV(SV *isv, char *file, int line);
extern SV *db_newSVsv(SV *isv, char *file, int line);
extern SV *db_newSVpv(char *str, STRLEN len, char *file, int line);
extern SV *db_newSViv(int ivar, char *file, int line);
extern SV *db_newSVnv(double nvar, char *file, int line);
/* pnx_dump.c */
extern void pnx_sv_dump(SV* sv);
/* pnx_fault.c */
extern void pnx_fault_boot();
extern void pnx_enable_fault_tolerance(SV *func);
/* pnx_fd.c */
extern void pnx_fd_boot();
extern FILE *pnx_get_notify_fh();
extern void pnx_register_fd_notifiers(SV *add_ref, SV *add_arg, SV *remove_ref, SV *remove_arg);
/* pnx_gp.c */
extern void pnx_gp_boot(void);
extern SV *pnx_gp_new(char *clas, SV *perlvar);
extern void pnx_gp_DESTROY(SV *self);
extern char *pnx_gp_as_string(SV *self);
extern void pnx_gp_print(SV *self);
extern int pnx_gp_is_local(SV *self);
extern SV *pnx_gp_dereference(SV *self);
extern nexus_global_pointer_t *pnx_gp_get_gp(SV *self, char *func);
/* pnx_lite.c */
extern int NexusBoot();
extern void pnx_boot();
extern SV *pnx_create_context(SV *gpref, char *pathname, int size);
extern SV *pnx_init_rsr(SV *gp_ref, char *subroutine);
extern SV *pnx__poll(int block);
extern SV *sv_list_to_object(int n_ptrs, SV **ptrs, char *objname);
/* pnx_mb.c */
extern void pnx_mb_boot(void);
extern void pnx_mb_sizeof_int(SV *self, int n_ints, int *size, int *n_elts);
extern void pnx_mb_sizeof_double(SV *self, int n_doubles, int *size, int *n_elts);
extern void pnx_mb_sizeof_char(SV *self, int n_chars, int *size, int *n_elts);
extern void pnx_mb_sizeof_global_pointer(SV *self, SV *gpsv, int *size, int *n_elts);
extern void pnx_mb_set_size(SV *self, int size, int n_elts);
extern void pnx_mb_put_int(SV *self, int intval);
extern void pnx_mb_put_double(SV *self, double doubleval);
extern void pnx_mb_put_string(SV *self, char *string, int len);
extern void pnx_mb_put_global_pointer(SV *self, SV *gpsv);
extern int pnx_mb_send_rsr(SV *self);
extern void pnx_mb_DESTROY(SV *self);
extern pnx_buffer_t *_pnx_mb_get_buffer(SV *self, char *func);
/* pnx_rrt.c */
extern SV *pnx_rref_new(SV *obj, char *type);
extern SV *pnx_rrt_new(SV *obj);
extern SV *pnx_rrt_gp(SV *rrt);
extern char *pnx_rrt_type(SV *rrt);
extern SV *pnx_rrt_ref(SV *rrt);
extern void pnx_rrt_incr(SV *rrt, int count);
extern void pnx_rrt_decr(SV *rrt, int count);
/* pnx_smb.c */
extern void pnx_smb_boot(void);
extern void pnx_smb_get_int(SV *self, SV *intref);
extern void pnx_smb_get_double(SV *self, SV *doubleref);
extern void pnx_smb_get_string(SV *self, SV *stringref, int len);
extern void pnx_smb_get_global_pointer(SV *self, SV *gpref);
extern void pnx_smb_DESTROY(SV *self);
extern nexus_stashed_buffer_t *_pnx_smb_get_buffer(SV *self, char *func);
